package at.ac.uibk.gitsearch.service.dto;

public class SearchInputMetadataDTO {
    private String programmingLanguage;
    private String keyword;
    private String naturalLanguage;
    private String license;
    private String author;

    public SearchInputMetadataDTO() {
    }

    public SearchInputMetadataDTO(String programmingLanguage,
                                  String keyword,
                                  String naturalLanguage,
                                  String license,
                                  String author) {
        this.programmingLanguage = mapEmptyString(programmingLanguage);
        this.keyword = mapEmptyString(keyword);
        this.naturalLanguage = mapEmptyString(naturalLanguage);
        this.license = mapEmptyString(license);
        this.author = mapEmptyString(author);
    }

    private static String mapEmptyString(String str) {
        return "".equals(str) ? null : str;
    }

    public boolean hasMetadataInput() {
        return !(programmingLanguage == null
            && keyword == null
            && author == null
            && license == null);
    }

    public String getProgrammingLanguage() {
        return programmingLanguage;
    }

    public void setProgrammingLanguage(String programmingLanguage) {
        this.programmingLanguage = mapEmptyString(programmingLanguage);
    }

    public String getKeyword() {
        return keyword;
    }

    public void setKeyword(String keyword) {
        this.keyword = mapEmptyString(keyword);
    }

    public String getNaturalLanguage() {
        return naturalLanguage;
    }

    public void setNaturalLanguage(String naturalLanguage) {
        this.naturalLanguage = mapEmptyString(naturalLanguage);
    }

    public String getLicense() {
        return license;
    }

    public void setLicense(String license) {
        this.license = mapEmptyString(license);
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = mapEmptyString(author);
    }

    @Override
    public String toString() {
        return "programmingLanguage: " + this.programmingLanguage
            + ", keyword: " + this.keyword
            + ", naturalLanguage: " + this.naturalLanguage
            + ", license: " + this.license
            + ", author: " + this.author;
    }
}
