import { Component, OnInit, Input } from '@angular/core';
import { Exercise } from '../shared/model/exercise.model';
import { Person } from 'app/shared/model/person.model';
import { PluginActionInfo } from 'app/shared/model/search/search-result-dto.model';
import { PluginService } from 'app/shared/service/plugin-service';
import { ShoppingBasketInfo, ShoppingBasketRedirectInfoDTO } from 'app/shared/model/basket/shopping-basket-info.model';

import { Location } from '@angular/common';

@Component({
  selector: 'jhi-exercise-details',
  templateUrl: './exercise-details.component.html',
  styleUrls: ['./exercise-details.component.scss'],
})
export class ExerciseDetailsComponent implements OnInit {
  @Input() exercise: Exercise | undefined;

  constructor(private pluginService: PluginService, private location: Location) {}

  ngOnInit(): void {}

  public getPersonName(person: Person): string {
    return person.name;
  }

  public getPersonDetails(person: Person): string {
    return "<a class='blackLink' href= 'mailto:'" + person.email + '>' + person.name + ', ' + person.affiliation + '</a>';
  }

  public arrayToString(array: string[]): string {
    let result = '';
    let i = 1;
    array.forEach(element => {
      if (array.length > 1 && array.length !== i) {
        result += element + ', ';
      } else {
        result += element;
      }
      if (i % 5 === 0) {
        result += '<br>';
      }
      i++;
    });
    return result;
  }

  public startAction(action: PluginActionInfo, exercise: Exercise):void {
		  const basketInfo: ShoppingBasketInfo = {
			plugin: action.plugin,
			action: action.action,
			itemInfos: [
				{
					exerciseID: "TODO: not yet defined" + exercise.license,
					gitLabURL: "TODO: not yet defined"
				}
			]
	    };
		this.pluginService.getRedirectLink(basketInfo).subscribe(
			(redirectInfo: ShoppingBasketRedirectInfoDTO) => {
	          // alert('redirecting to ' + redirectInfo.redirectURL);
				location.href = redirectInfo.redirectURL;
//				window.open(redirectInfo.redirectURL/* , action.plugin */);
        },
        () => alert('Search failed') )
	}
}
