import { Person } from 'app/shared/model/person.model';
import { IExerciseType } from './search/exercise-type.model';
import { SearchResultsDTO } from 'app/shared/model/search/search-results-dto.model';
import { PluginActionInfo } from 'app/shared/model/search/search-result-dto.model';


export interface Exercise {
  // from metadata (required)
  title: string;
  license: string;

  // from metadata (optional)
  description: string;
  programmingLanguages: string[];
  languages: string[];
  creators: Person[];
  publisher: Person[];
  contributor: Person[];
  requires: string[];
  imageURL: string;
  timeRequired: string;
  deprecated: boolean;
  difficulty: string;
  educationLevel: string;
  format: Array<string>;
  keyword: Array<string>;
  //language: Array<string>;
  //repositoryURL: string;
  //source: Array<string>;
  status: string;
  //structure: string;
  type: IExerciseType;
  structure: string;
  version: string;
  metadataVersion: string;

  // not in metadata
  rating: number;
  lastUpdate: string;
  supportedActions: PluginActionInfo[];
}
